apiVersion: batch/v1
kind: Job
metadata:
  name: {{ include "common.fullname" . }}-post-install
  labels:
    app.kubernetes.io/managed-by: {{.Release.Service | quote }}
    app.kubernetes.io/instance: {{include "common.release" . | quote }}
    helm.sh/chart: "{{.Chart.Name}}-{{.Chart.Version}}"
    release: {{ include "common.release" . }}
  annotations:
    # This is what defines this resource as a hook. Without this line, the
    # job is considered part of the release.
    #"helm.sh/hook": post-install
    #"helm.sh/hook-weight": "-4"
    #"helm.sh/hook-delete-policy": hook-succeeded
spec:
  backoffLimit: 20
  template:
    metadata:
      name: {{ include "common.fullname" . }}
      labels:
        app.kubernetes.io/managed-by: {{.Release.Service | quote }}
        app.kubernetes.io/instance: {{include "common.release" . | quote }}
        helm.sh/chart: "{{.Chart.Name}}-{{.Chart.Version}}"
        release: {{ include "common.release" . }}
    spec:
      restartPolicy: Never
      initContainers:
      - name: {{ include "common.name" . }}-init-readiness
        image: "{{ .Values.global.readinessRepository }}/{{ .Values.global.readinessImage }}"
        imagePullPolicy: {{ .Values.global.pullPolicy | default .Values.pullPolicy }}
        command:
        - /root/ready.py
        args:
        - --container-name
        - message-router
        env:
        - name: NAMESPACE
          valueFrom:
            fieldRef:
              apiVersion: v1
              fieldPath: metadata.namespace
      containers:
      - name: post-install-job
        image: "{{ include "common.repository" . }}/{{ .Values.global.clientImage }}"
        imagePullPolicy: "Always"
        env:
        - name: DELAY
          value: "30"
    {{- if .Values.global.allow_http }}
        - name: PROTO
          value: "http"
        - name: PORT
          value: "8080"
    {{ end }}
        - name: REQUESTID
          value: "{{.Chart.Name}}-post-install"
        volumeMounts:
        - mountPath: /etc/localtime
          name: localtime
          readOnly: true

# NOTE: on the following several configMaps, careful to include / at end
#       since there may be more than one file in each mountPath
# NOTE: the basename of the subdirectory of mountPath is important - it matches the DBCL API URI
        - name: {{ include "common.fullname" . }}-dbc-mrclusters
          mountPath: /opt/app/config/mr_clusters/
        - name: {{ include "common.fullname" . }}-dbc-topics
          mountPath: /opt/app/config/topics/
        resources:
{{ include "common.resources" . | indent 10 }}
        {{- if .Values.nodeSelector }}
      nodeSelector:
{{ toYaml .Values.nodeSelector | indent 8 }}
        {{- end -}}
        {{- if .Values.affinity }}
      affinity:
{{ toYaml .Values.affinity | indent 8 }}
        {{- end }}
      volumes:
        - name: localtime
          hostPath:
            path: /etc/localtime
        - name: {{ include "common.fullname" . }}-dbc-mrclusters
          configMap:
            name: {{ include "common.fullname" . }}-dbc-mrclusters
        - name: {{ include "common.fullname" . }}-dbc-topics
          configMap:
            name: {{ include "common.fullname" . }}-dbc-topics
      imagePullSecrets:
      - name: "{{ include "common.namespace" . }}-docker-registry-key"
